Option Explicit
'COMMON USED GLOBALS AND VARIABELS
Global Const MaxIOcard% = 3
Global Const MaxIOchip% = 7
Global Const MaxIOchannel% = 64
Global Const MaxDACchannel% = 32
Global Const MaxADchannel% = 16
Global Const MaxDAchannel% = 4
Global Const StartValue% = 0

Global IOconfig%(MaxIOchip%)
Global IOdata%(MaxIOchip%)
Global IO%(MaxIOchannel%)
Global DAC%(MaxDACchannel%)
Global AD%(MaxADchannel%)
Global DA%(MaxDAchannel%)

Global ADDAchipCode%(MaxIOcard%)
Global DACchipCode%(MaxIOcard%)
Global IOChipCode%(MaxIOchip%)

Global Statusport As Integer
Global Controlport As Integer
Global I2Cbusdelay As Integer

Dim Effect1(255) As Integer
Dim Effect2(255) As Integer
Dim Effect3(255) As Integer
Dim Effectl4(255) As Integer
Dim Effecth4(255) As Integer

'function and sub for parallel port data access
'Use just like their QuickBasic Counterparts
'Out port%,Value ----- or X% = Inp(Port%)

Declare Function Inp Lib "InpOut16.DLL" (ByVal port%) As Integer
Declare Sub out Lib "InpOut16.DLL" (ByVal port%, ByVal Value%)

Function BINNOT% (Dec%)
    Dim temp$, Complement$, i%
     temp$ = DecToBin(Dec%)
     Complement$ = ""
     For i% = 1 To Len(temp$)
	If Mid$(temp$, i%, 1) = "1" Then
	    Complement$ = Complement$ + "0"
	Else
	    Complement$ = Complement$ + "1"
	End If
     Next
     BINNOT% = BinToDec(Complement$)
End Function

Function BinToDec% (BinNumber$)
    Dim Weight%
    Dim Dec%
    Dim i%
    Weight% = 1
    Dec% = 0                       'Reset decimal number

    If BinNumber$ <> "00000000" Then
	For i% = Len(BinNumber$) To 1 Step -1
	    If Mid$(BinNumber$, i%, 1) = "1" Then
		Dec% = Dec% + Weight%  'If bit=1 then add weigth factor
	    End If
	    Weight% = Weight% * 2  'Multiply weight factor by 2
	Next
	BinToDec% = Dec%        'Store result
    Else
	BinToDec% = 0
    End If
End Function

Sub ClearAllDA ()
    Dim ChannelNo%
    For ChannelNo% = 1 To MaxDAchannel%
	OutputDAchannel ChannelNo%, 0
    Next
End Sub

Sub ClearAllDAC ()
    Dim ChannelNo%
    For ChannelNo% = 1 To MaxDACchannel
	DAC%(ChannelNo%) = 0
    Next
    UpdateAllDAC
End Sub

Sub ClearAllIO ()
    Dim ChipNo%
    For ChipNo% = 0 To MaxIOchip%
	IOoutput ChipNo%, 0
    Next
End Sub

Sub ClearDACchannel (ChannelNo%)
    OutputDACchannel ChannelNo%, 0
End Sub

Sub ClearDACchip (ChipNo%)
    Dim Channel%, i%
    Channel% = ChipNo% * 8
    For i% = 1 To 8
	DAC%(Channel% + i%) = 0
    Next
    UpdateDACchip ChipNo%
End Sub

Sub ClearDAchannel (ChannelNo%)
    OutputDAchannel ChannelNo%, 0
End Sub

Sub ClearIOchannel (ChannelNo%)
    Dim Channel%
    Dim Datavar%, ChipNo%
    ChipNo% = (ChannelNo% - 1) \ 8
    Channel% = (ChannelNo% - 1) Mod 8
    Datavar% = IOdata%(ChipNo%) And BINNOT(SHL(1, Channel%))
    IOoutput ChipNo%, Datavar%
End Sub

Sub ClearIOchArray (ChannelNo%)
    Dim Channel%
    Dim Datavar%, ChipNo%
    ChipNo% = (ChannelNo% - 1) \ 8
    Channel% = (ChannelNo% - 1) Mod 8
    Datavar% = IOdata%(ChipNo%) And BINNOT(SHL(1, Channel%))
    UpdateIOdataArray ChipNo%, Datavar%
End Sub

Sub ClearIOChip (ChipNo%)
    IOoutput ChipNo%, 0
End Sub

Sub ClearIOdataArray (ChipNo%)
     Dim StartChannel%
     Dim temp%
     Dim Datavar$
     Dim Channel%
    'Update IOdata array
    IOdata%(ChipNo) = IOdata%(ChipNo) And IOconfig%(ChipNo)

    'Update IO array
    StartChannel% = ChipNo% * 8 + 1
    temp% = IOdata%(ChipNo%)
    Datavar$ = DecToBin(temp%)
    For Channel% = 0 To 7
	If Mid$(Datavar$, 8 - Channel%, 1) = "1" Then
	    IO%(StartChannel% + Channel%) = 1
	Else
	    IO%(StartChannel% + Channel%) = 0
	End If
    Next
End Sub

' IO CONFIGURATION SUBROUTINES
Sub ConfigAllIOasInput ()
    Dim ChipNo%
    For ChipNo% = 0 To MaxIOchip%
	IOconfig%(ChipNo%) = 0
	ClearIOChip ChipNo%
	IOconfig%(ChipNo%) = 255
	ReadIOchip ChipNo%
    Next
End Sub

Sub ConfigAllIOasOutput ()
    Dim ChipNo%
    For ChipNo% = 0 To MaxIOchip%
	IOconfig%(ChipNo%) = 0
    Next
    ClearAllIO
End Sub

Sub ConfigIOChannelAsInput (ChannelNo%)
    Dim Channel%, ChipNo%
    ChipNo% = (ChannelNo% - 1) \ 8
    Channel% = (ChannelNo% - 1) Mod 8
    IOconfig%(ChipNo%) = IOconfig%(ChipNo%) And BINNOT(SHL(1, Channel%))
    ClearIOchannel ChannelNo%
    IOconfig%(ChipNo%) = IOconfig%(ChipNo%) Or SHL(1, Channel%)
    ReadIOchannel ChannelNo%
End Sub

Sub ConfigIOchannelAsOutput (ChannelNo%)
    Dim Channel%, ChipNo%
    ChipNo% = (ChannelNo% - 1) \ 8
    Channel% = (ChannelNo% - 1) Mod 8
    IOconfig%(ChipNo%) = IOconfig%(ChipNo%) And BINNOT(SHL(1, Channel%))
    ClearIOchannel ChannelNo%
End Sub

Sub ConfigIOchipAsInput (ChipNo%)
    IOconfig%(ChipNo%) = 0
    ClearIOChip ChipNo%
    IOconfig%(ChipNo%) = 255
    ReadIOchip ChipNo%
End Sub

Sub ConfigIOchipAsOutput (ChipNo%)
    IOconfig%(ChipNo%) = 0
    ClearIOChip ChipNo%
End Sub

Function DecTo7seg (Decnumber As Integer) As Integer
' Zet een Decimaal getal van 0..9 om in een 7-segment
' tegenwaarde voor sturing van een 7 segment display
' via I2C-bus
    
    Dim temp As Integer
    Select Case Decnumber
	Case 0
	    temp = 63
	Case 1
	    temp = 6
	Case 2
	    temp = 91
	Case 3
	    temp = 79
	Case 4
	    temp = 102
	Case 5
	    temp = 109
	Case 6
	    temp = 125
	Case 7
	    temp = 7
	Case 8
	    temp = 127
	Case 9
	    temp = 111
   End Select
DecTo7seg = temp
End Function

' RADIX CONVERSION SUBROUTINES
Function DecToBin$ (Decnumber%)
    'Conversion of decimal number (0...255) to 8 bit binary string.
    '--------------------------------------------------------------
    Dim Bin$
    Dim Faktor%, i%

    Bin$ = ""
    Faktor% = 128

    If Decnumber% <> 0 Then
	For i% = 1 To 8
	    If Faktor% > Decnumber% Then
		Bin$ = Bin$ + "0"
	    Else
		Bin$ = Bin$ + "1"
		Decnumber% = Decnumber% - Faktor%
	    End If
	    Faktor% = Faktor% \ 2
	Next
	DecToBin$ = Bin$
    Else
	DecToBin$ = "00000000"
    End If
End Function

Function DecToHex$ (Decnumber%)
    DecToHex = Hex$(Decnumber%)
End Function

Function HexToDec% (Hexnumber$)
    Dim StrLength%
    Dim decl%
    Dim dech%
    
    Dim StrLenght%
    StrLength% = 0
    decl% = 0
    dech% = 0
    Hexnumber$ = UCase$(Hexnumber$)
    StrLength% = Len(Hexnumber$)
    decl% = Asc(Mid$(Hexnumber$, StrLength%, 1))
    If decl% >= Asc("A") Then
	decl% = decl% - Asc("A") + 10
    Else
	decl% = decl% - Asc("0")
    End If
    If StrLength% = 2 Then
	dech% = Asc(Mid$(Hexnumber$, 1, 1))      'Convert most significant digit
	If dech% > Asc("A") Then               'Digit > 9 subtract offset A...F
	    dech% = dech% - Asc("A") + 10
	Else
	    dech% = dech% - Asc("0")
	End If
    End If
    HexToDec% = 16 * dech% + decl%
End Function

Sub I2CBusNotBusy ()
    Dim i%
    out Controlport%, 4
    For i% = 0 To I2Cbusdelay%
    Next
    
End Sub

Sub I2Cclockpulse ()
' Veroorzaak een look-alike Ack-puls op I2C-bus
    Dim i%
    out Controlport%, 12
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 4
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 12
    For i% = 0 To I2Cbusdelay%
    Next
End Sub

Sub I2CInit ()
    SelectI2CprinterPort 1
    I2Cbusdelay% = 1
    I2CBusNotBusy
    ConfigAllIOasInput
	ClearAllDAC
	ClearAllDA
	ReadAll
End Sub

Function I2CInput% ()
    Dim Serdata%
    Dim j%, i%
    Dim Inputdata%
    Serdata% = 0
    For j% = 1 To 8
	Serdata% = SHL(Serdata%, 1)
	out Controlport, 4
	For i% = 0 To I2Cbusdelay%
	Next

	Inputdata% = Inp(Statusport%) And 16
	If Inputdata% <> 0 Then
	    Serdata% = Serdata% Or 1
	End If

	out Controlport%, 12
	For i% = 0 To I2Cbusdelay%
	Next
    Next
    I2CInput% = Serdata%
End Function

Sub I2Cmasterclockpulse ()
    Dim i%
    out Controlport%, 14
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 6
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 14
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 12
    For i% = 0 To I2Cbusdelay%
    Next
End Sub

Sub I2COutput (Serdata%)
    Dim temp%
    Dim Serdat$
    Dim j%
    Dim DataOut%
    Dim i%
    temp% = Serdata%
    Serdat$ = DecToBin(temp%)

    For j% = 1 To 8

	If Mid$(Serdat$, j%, 1) = "1" Then
	    DataOut% = 12
	Else
	    DataOut% = 14
	End If
	out Controlport%, DataOut%
	For i% = 0 To I2Cbusdelay%
	Next

	DataOut% = Inp(Controlport%) And 7
	out Controlport%, DataOut%
	For i% = 0 To I2Cbusdelay%
	Next

	DataOut% = Inp(Controlport%) Or 8
	out Controlport%, DataOut%
	For i% = 0 To I2Cbusdelay%
	Next
    Next
End Sub

Sub I2Cstart ()
    Dim i%
    out Controlport%, 6
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 14
    For i% = 0 To I2Cbusdelay%
    Next
End Sub

Sub I2CStop ()
    Dim i%
    out Controlport%, 14
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 6
    For i% = 0 To I2Cbusdelay%
    Next

    out Controlport%, 4
    For i% = 0 To I2Cbusdelay%
    Next
End Sub

Sub init ()
' Initialiseerd de I2C Bus
    Dim i%
    out Controlport%, 4
    For i% = 0 To I2Cbusdelay%
    Next

End Sub

' OUTPUT SUBROUTINES
Sub IOoutput (ChipNo%, Datavar%)
    Dim temp%
    Dim StartChannel%, Channel%
    Dim Datvar$
    temp% = Datavar%
    Datavar% = BINNOT(temp%) Or IOconfig%(ChipNo%)

    I2Cstart

    temp% = IOChipCode%(ChipNo%)
    I2COutput temp%

    I2Cclockpulse

    temp% = Datavar%
    I2COutput temp%

    I2Cclockpulse

    I2CStop

    IOdata%(ChipNo%) = (IOdata%(ChipNo%) And IOconfig%(ChipNo%)) Or BINNOT(Datavar%)


    StartChannel% = ChipNo% * 8 + 1
    temp% = IOdata%(ChipNo%)
    Datvar$ = DecToBin(temp%)
    For Channel% = 0 To 7
	If Mid$(Datvar$, 8 - Channel%, 1) = "1" Then
	    IO%(StartChannel% + Channel%) = 1
	Else
	    IO%(StartChannel% + Channel%) = 0
	End If
    Next
End Sub

Sub main ()
    Dim CardNo%
    Dim ChipNo%
    Dim i%
    Dim PauseFactor%
    Dim j%
    Dim seconds%
    Dim oldsecond%
    Dim temp%
    Dim wait%
    Dim wait1%
    
    For CardNo% = 0 To MaxIOcard%
	DACchipCode%(CardNo%) = 64 + 2 * CardNo%
	ADDAchipCode%(CardNo%) = 144 + 2 * CardNo%
    Next

    For ChipNo% = 0 To MaxIOchip%
	IOChipCode%(ChipNo%) = 112 + 2 * ChipNo%
    Next

 I2CInit

	i% = 0
	PauseFactor% = 0
	seconds% = Val(Mid$(Time$, 7, 2))
	oldsecond% = seconds%
	Do
			For j% = 0 To 10
				seconds% = Val(Mid$(Time$, 7, 2))
				If seconds% <> oldsecond% Then
					i% = i% + 1
						oldsecond% = seconds%
				End If
			Next
			PauseFactor% = PauseFactor% + 1
	Loop Until i% = 3

READEffect1
READEffect2
READEffect3
READEffectl4
ReadEffecth4


SelectI2CprinterPort 1  '{select lpt1 on mainboard}
								'{for other printerports change parameter}
	I2Cbusdelay% = 10       '{adjust I2C-speed}
								'{increase when using a very fast PC}
	ConfigIOchipAsOutput 0  '{configure channels 1...8 as outputs}
	ConfigIOchipAsOutput 1  '{configure channels 9...16 as outputs}


MsgBox "APPLICATION : 16 CHANNEL LIGHTCOMPUTER (LIGHTEFFECT) SW1 switch setting OFF-OFF (IOcard no 0) Using channels 1 to 16 as outputs Press BREAK to exit"

Do
		For j% = 1 To 3   '{run lighteffect 1 three times}
	   
			For i% = 1 To 36
				temp% = Effect1%(i%)
				IOoutput 0, temp%
				temp% = Effect1%(i%)
				IOoutput 1, temp%
If PauseFactor% <> 0 Then
	For wait% = 0 To PauseFactor%
	    For wait1% = 0 To 100
	    Next
	Next
    End If
   

			Next
		Next
		For j% = 1 To 4   '{run lighteffect 2 four times}
			For i% = 1 To 8
				temp% = Effect2%(i%)
				IOoutput 0, temp%
				temp% = Effect2%(i%)
				IOoutput 1, temp%
If PauseFactor% <> 0 Then
	For wait% = 0 To PauseFactor%
	    For wait1% = 0 To 100
	    Next
	Next
    End If
			 
			Next
		Next
		For j% = 1 To 5    '{run lighteffect 3 five times}
			For i% = 1 To 4
				temp% = Effect3%(i%)
				IOoutput 0, temp%
				temp% = Effect3%(i%)
				IOoutput 1, temp%
If PauseFactor% <> 0 Then
	For wait% = 0 To PauseFactor%
	    For wait1% = 0 To 100
	    Next
	Next
    End If

			Next
		Next
		For j = 1 To 6    '{run lighteffect 4 six times}
			For i% = 1 To 8
				temp% = Effectl4%(i%)
				IOoutput 0, temp%
				temp% = Effecth4%(i%)
				IOoutput 1, temp%
If PauseFactor% <> 0 Then
	For wait% = 0 To PauseFactor%
	    For wait1% = 0 To 100
	    Next
	Next
    End If

			Next
		Next
	Loop Until i = 3000

End Sub

' 6 BIT DAC CONVERTER SUBROUTINES
Sub OutputDACchannel (ChannelNo%, Datavar%)
    Dim Serdata%
    If Datavar% > 63 Then
	 Datavar% = 63
      End If
    DAC%(ChannelNo%) = Datavar%

    I2Cstart

    Serdata% = DACchipCode%((ChannelNo% - 1) \ 8)
    I2COutput Serdata%

    I2Cclockpulse

    Serdata% = 240 Or ((ChannelNo% - 1) Mod 8)
    I2COutput Serdata%

    I2Cclockpulse

    I2COutput Datavar%

    I2Cclockpulse

    I2CStop
End Sub

' 8 BIT DA CONVERTER SUBROUTINES
Sub OutputDAchannel (ChannelNo%, Datavar%)
    Dim temp%
    DA%(ChannelNo%) = Datavar
    I2Cstart

    temp% = ADDAchipCode%(ChannelNo% - 1)
    I2COutput temp%

    I2Cclockpulse

    I2COutput 64

    I2Cclockpulse

    I2COutput Datavar%

    I2Cclockpulse

    I2CStop
End Sub

'8 BIT AD CONVERTER SUBROUTINES
Sub ReadADchannel (ChannelNo%)
    Dim ChipCode%, Serdata%
    ChipCode% = ADDAchipCode%((ChannelNo% - 1) \ 4)

    I2Cstart

    I2COutput ChipCode%

    I2Cclockpulse

    Serdata% = 64 Or ((ChannelNo% - 1) Mod 4)
    I2COutput Serdata%

    I2Cclockpulse

    I2CStop

    I2Cstart

    Serdata% = ChipCode% Or 1
    I2COutput Serdata%

    I2Cclockpulse

    AD%(ChannelNo%) = I2CInput()

    I2Cmasterclockpulse

    AD%(ChannelNo%) = I2CInput()

    I2Cclockpulse

    I2CStop
End Sub

Sub ReadADchip (ChipNo%)
    Dim Channel%, temp%, Serdata%, k%
    Channel% = ChipNo% * 4 + 1

    I2Cstart

    temp% = ADDAchipCode%(ChipNo%)
    I2COutput temp%

    I2Cclockpulse

    I2COutput 68

    I2Cclockpulse

    I2CStop

    I2Cstart

    temp% = ADDAchipCode%(ChipNo%) Or 1
    I2COutput temp%

    I2Cclockpulse

    Serdata% = I2CInput()

    For k% = 0 To 3
	I2Cmasterclockpulse
	Serdata% = I2CInput()
	AD%(Channel% + k%) = Serdata%
    Next

    I2Cclockpulse

    I2CStop
End Sub

'GENERAL SUBROUTINES
Sub ReadAll ()
    ReadAllIO
    ReadAllAD
End Sub

Sub ReadAllAD ()
    Dim CardNo%
    Dim ard
    For CardNo% = 0 To MaxIOcard%
	ReadADchip CardNo%
    Next
End Sub

Sub ReadAllIO ()
    Dim ChipNo%
    For ChipNo% = 0 To MaxIOchip%
	ReadIOchip ChipNo%
    Next
End Sub

Sub ReadCard (CardNo%)
    Dim ChipNo%
    ChipNo% = CardNo% * 2
    ReadIOchip ChipNo%
    ReadIOchip ChipNo% + 1
    ReadADchip CardNo%
End Sub

Sub READEffect1 ()
Effect1(1) = 1
Effect1(2) = 2
Effect1(3) = 4
Effect1(4) = 8
Effect1(5) = 16
Effect1(6) = 32
Effect1(7) = 64
Effect1(8) = 128
Effect1(9) = 129
Effect1(10) = 130
Effect1(11) = 132
Effect1(12) = 136
Effect1(13) = 144
Effect1(14) = 160
Effect1(15) = 192
Effect1(16) = 193
Effect1(17) = 194
Effect1(18) = 196
Effect1(19) = 200
Effect1(20) = 208
Effect1(21) = 224
Effect1(22) = 225
Effect1(23) = 226
Effect1(24) = 228
Effect1(25) = 232
Effect1(26) = 240
Effect1(27) = 241
Effect1(28) = 242
Effect1(29) = 244
Effect1(30) = 248
Effect1(31) = 249
Effect1(32) = 250
Effect1(33) = 252
Effect1(34) = 253
Effect1(35) = 254
Effect1(36) = 255

'  Effect1 : ARRAY%(1 TO 36)
'    (1,    {x       x       }
'     2,    { x       x      }
'     4,    {  x       x     }
'     8,    {   x       x    }
'     16,   {    x       x   }
'     32,   {     x       x  }
'     64,   {      x       x }
'     128,  {       x       x}
'     129,  {x      xx      x}
'     130,  { x     x x     x}
'     132,  {  x    x  x    x}
'     136,  {   x   x   x   x}
'     144,  {    x  x    x  x}
'     160,  {     x x     x x}
'     192,  {      xx      xx}
'     193,  {x     xxx     xx}
'     194,  { x    xx x    xx}
'     196,  {  x   xx  x   xx}
'     200,  {   x  x    x  xx}
'     208,  {    x xx    x xx}
'     224,  {     xxx     xxx}
'     225,  {x    xxxx    xxx}
'     226,  { x   xxx x   xxx}
'     228,  {  x  xxx  x  xxx}
'     232,  {   x xxx   x xxx}
'     240,  {    xxxx    xxxx}
'     241,  {x   xxxxx   xxxx}
'     242,  { x  xxxx x  xxxx}
'     244,  {  x xxxx  x xxxx}
'     248,  {   xxxxx   xxxxx}
'     249,  {x  xxxxxx  xxxxx}
'     250,  { x xxxxx x xxxxx}
'     252,  {  xxxxxx  xxxxxx}
'     253,  {x xxxxxxx xxxxxx}
'     254,  { xxxxxxx xxxxxxx}
'     255   {xxxxxxxxxxxxxxxx}
End Sub

Sub READEffect2 ()
Effect2(1) = 1
Effect2(2) = 2
Effect2(3) = 4
Effect2(4) = 8
Effect2(5) = 16
Effect2(6) = 32
Effect2(7) = 64
Effect2(8) = 128

'  Effect2: ARRAY%(1..8) OF Integer =
'     1,    {x       x       }
'     2,    { x       x      }
'     4,    {  x       x     }
'     8,    {   x       x    }
'     16,   {    x       x   }
'     32,   {     x       x  }
'     64,   {      x       x }
'     128   {       x       x}
End Sub

Sub READEffect3 ()
Effect3(1) = 17
Effect3(2) = 34
Effect3(3) = 68
Effect3(4) = 136

'  Effect3: ARRAY%(1..4) OF Integer =
'     17,   {x   x   x   x   }
'     34,   { x   x   x   x  }
'     68,   {  x   x   x   x }
'     136   {   x   x   x   x}
End Sub

Sub ReadEffecth4 ()
Effecth4(1) = 128
Effecth4(2) = 192
Effecth4(3) = 224
Effecth4(4) = 240
Effecth4(5) = 248
Effecth4(6) = 252
Effecth4(7) = 254
Effecth4(8) = 255

'  Effecth4 : ARRAY%(1..8) OF Integer =
'     128  {x              x}
'     192  {xx            xx}
'     224  {xxx          xxx}
'     240  {xxxx        xxxx}
'     248  {xxxxx      xxxxx}
'     252  {xxxxxx    xxxxxx}
'     254  {xxxxxxx  xxxxxxx}
'     255  {xxxxxxxxxxxxxxxx}

End Sub

Sub READEffectl4 ()
Effectl4%(1) = 1
Effectl4%(2) = 3
Effectl4%(3) = 7
Effectl4%(4) = 15
Effectl4%(5) = 31
Effectl4%(6) = 63
Effectl4%(7) = 127
Effectl4%(8) = 255


'  Effectl4 : ARRAY%(1..8) OF Integer =
'     1,    {x              x}
'     3,    {xx            xx}
'     7,    {xxx          xxx}
'     15,   {xxxx        xxxx}
'     31,   {xxxxx      xxxxx}
'     63,   {xxxxxx    xxxxxx}
'     127,  {xxxxxxx  xxxxxxx}
'     255   {xxxxxxxxxxxxxxxx}

End Sub

Sub ReadIOchannel (ChannelNo%)
    Dim ChipNo%
    ChipNo% = (ChannelNo% - 1) \ 8
    ReadIOchip ChipNo%
End Sub

' INPUT SUBROUTINES
Sub ReadIOchip (ChipNo%)
    Dim Datavar%, StartChannel%, temp%, Datvar$, Channel%
    I2Cstart

    Datavar% = IOChipCode%(ChipNo%) Or 1
    I2COutput Datavar%

    I2Cclockpulse

    IOdata%(ChipNo%) = I2CInput()
    IOdata%(ChipNo%) = BINNOT(IOdata%(ChipNo%))
    I2Cclockpulse

    I2CStop

    StartChannel% = ChipNo% * 8 + 1
    temp% = IOdata%(ChipNo%)
    Datvar$ = DecToBin(temp%)
    For Channel% = 0 To 7
	If Mid$(Datvar$, 8 - Channel%, 1) = "1" Then
	    IO%(StartChannel% + Channel%) = 1
	Else
	    IO%(StartChannel% + Channel%) = 0
	End If
    Next
End Sub

Sub SelectI2CprinterPort (PrinterNo%)
    Select Case PrinterNo
	Case 0
	    Statusport% = 957
	    Controlport% = 958
	Case 1
	    Statusport% = 889
	    Controlport% = 890
	Case 2
	    Statusport% = 633
	    Controlport% = 634
	End Select
End Sub

Sub SetAllDA ()
    Dim ChannelNo%
    For ChannelNo% = 1 To MaxDAchannel%
	OutputDAchannel ChannelNo%, 255
    Next
End Sub

Sub SetAllDAC ()
    Dim ChannelNo%
    For ChannelNo% = 1 To MaxDACchannel
	DAC%(ChannelNo%) = 63
    Next
    UpdateAllDAC
End Sub

Sub SetAllIO ()
    Dim ChipNo%
    For ChipNo% = 0 To MaxIOchip%
       IOoutput ChipNo%, 255
    Next
End Sub

Sub SetDACchannel (ChannelNo%)
    OutputDACchannel ChannelNo%, 63
End Sub

Sub SetDACchip (ChipNo%)
    Dim Channel%, i%
    Channel% = ChipNo% * 8
    For i% = 1 To 8
	DAC%(Channel% + i%) = 63
    Next
    UpdateDACchip ChipNo%
End Sub

Sub SetDAchannel (ChannelNo%)
    OutputDAchannel ChannelNo%, 255
End Sub

Sub SetIOchannel (ChannelNo%)
    Dim ChipNo%, Channel%, Datavar%
    ChipNo% = (ChannelNo% - 1) \ 8
    Channel% = (ChannelNo% - 1) Mod 8
    Datavar% = SHL(1, Channel%) Or IOdata%(ChipNo%)
    IOoutput ChipNo%, Datavar%
End Sub

Sub SetIOchArray (ChannelNo%)
    Dim ChipNo%, Channel%, Datavar%
    ChipNo% = (ChannelNo% - 1) \ 8
    Channel% = (ChannelNo% - 1) Mod 8
    Datavar% = IOdata%(ChipNo%) Or SHL(1, Channel%)
    UpdateIOdataArray ChipNo%, Datavar%
End Sub

Sub SetIOchip (ChipNo%)
    IOoutput ChipNo%, 255
End Sub

Sub SetIOdataArray (ChipNo%)
     Dim temp%, StartChannel%, Datvar$, Channel%
    ' Update IOdata array
    temp% = IOconfig%(ChipNo%)
    IOdata%(ChipNo%) = IOdata%(ChipNo%) Or (BINNOT(temp%))

    ' Updata IO array
    StartChannel% = ChipNo% * 8 + 1
    temp% = IOdata%(ChipNo%)
    Datvar$ = DecToBin(temp%)
    For Channel% = 0 To 7
	If Mid$(Datvar$, 8 - Channel%, 1) = "1" Then
	    IO%(StartChannel% + Channel%) = 1
	Else
	    IO%(StartChannel% + Channel%) = 0
	End If
    Next
End Sub

Function SHL% (Dec%, Positions%)
    Dim temp$
    temp$ = Right$(DecToBin(Dec%) + String$(Positions%, "0"), 8)
    SHL = BinToDec(temp$)
End Function

Sub UpdateAll ()
    UpdateAllIO
    UpdateAllDAC
    UpdateAllDA
End Sub

Sub UpdateAllDA ()
    Dim ChannelNo%, temp%
    For ChannelNo% = 1 To MaxDAchannel%
	temp% = DA%(ChannelNo%)
	OutputDAchannel ChannelNo%, temp%
    Next
End Sub

Sub UpdateAllDAC ()
    Dim CardNo%
    For CardNo% = 0 To MaxIOcard%
	UpdateDACchip CardNo%
    Next
End Sub

Sub UpdateAllIO ()
    Dim ChipNo%, temp%
    For ChipNo% = 0 To MaxIOchip%
	temp% = IOdata%(ChipNo%)
	IOoutput ChipNo%, temp%
    Next
End Sub

Sub UpdateCard (CardNo%)
    Dim ChipNo%
    ChipNo% = CardNo% * 2
    UpdateIOchip ChipNo%
    UpdateIOchip ChipNo% + 1
    UpdateDACchip CardNo%
    UpdateDAchannel CardNo% + 1
End Sub

Sub UpdateDACchannel (ChannelNo%)
    Dim temp%
    temp% = DAC%(ChannelNo%)
    OutputDACchannel ChannelNo%, temp%
End Sub

Sub UpdateDACchip (ChipNo%)
    Dim Serdata%, Channel%, k%, temp%
    I2Cstart

    Serdata% = DACchipCode%(ChipNo%)
    I2COutput Serdata%

    I2Cclockpulse

    I2COutput 0

    I2Cclockpulse

    Channel% = ChipNo% * 8
    For k% = 1 To 8
	If DAC%(Channel% + k%) > 63 Then
	    DAC%(Channel% + k%) = 63
	End If
	temp% = DAC%(Channel% + k%)
	I2COutput temp%
	I2Cclockpulse
    Next

    I2CStop
End Sub

Sub UpdateDAchannel (ChannelNo%)
    Dim temp%
    temp% = DA%(ChannelNo%)
    OutputDAchannel ChannelNo%, temp%
End Sub

Sub UpdateIOchip (ChipNo%)
    Dim temp%
    temp% = IOdata%(ChipNo%)
    IOoutput ChipNo%, temp%
End Sub

' UPDATE IODATA & IO ARRAY SUBROUTINES
Sub UpdateIOdataArray (ChipNo%, Datavar%)
    Dim temp%, StartChannel%, Datvar$, Channel%
    ' Update IOdata array
    IOdata%(ChipNo%) = IOdata%(ChipNo%) And IOconfig%(ChipNo%)
    temp% = IOconfig%(ChipNo%)
    IOdata%(ChipNo%) = IOdata%(ChipNo%) Or (Datavar% And BINNOT(temp%))

    'Update IO array
    StartChannel% = ChipNo% * 8 + 1
    temp% = IOdata%(ChipNo%)
    Datvar$ = DecToBin(temp%)
    For Channel% = 0 To 7
	If Mid$(Datvar$, 8 - Channel%, 1) = "1" Then
	    IO%(StartChannel% + Channel%) = 1
	Else
	    IO%(StartChannel% + Channel%) = 0
	End If
    Next
End Sub

